function [z,fstr]=fct2D(x,y,function_type,deg)

%--------------------------------------------------------------------------
% FUNCTION DEFINITION.
%--------------------------------------------------------------------------
%
% INPUT:
%
% [x,y]: EVALUATE THE FUNCTION IN THE POINTS (x,y). "x", "y" ARE COLUMN VECTORS.
%
% [function_type]: PARAMETER THAT CHOOSES THE FUNCTION.
%
% OUTPUT:
%
% [z]: VALUE OF THE FUNCTION IN THE POINTS (x,y). IT IS A COLUMN VECTOR.
%
%--------------------------------------------------------------------------

switch function_type
    case 1
        z=franke(x,y);
        fstr='franke';
    case 2
        z=( (x-0.5).^2 +(y-0.5).^2 ).^(1/2);
        fstr='( (x-0.5).^2 +(y-0.5).^2 ).^(1/2)';
    case 3
        a=0.564; b=0.274; c=1.364;
        z=(a*x+b*y+c).^deg;
        fstr='(a*x+b*y+c).^deg';
    case 4
        loc_arg=(x-0.5).^2+(y-0.5).^2;
        z=exp(loc_arg);
        fstr='exp((x-0.5).^2+(y-0.5).^2)';
    case 5
        loc_arg=(x-0.5).^2+(y-0.5).^2;
        z=exp(-100*loc_arg);
        fstr='exp(-100*((x-0.5).^2+(y-0.5).^2))';
    case 6
        z=cos(30*(x+y));
        fstr='cos(30*(x+y))';
    case 7
        z=ones(size(x));
        fstr='1';
    case 8
        z=exp(5*(x-y));
        fstr='exp(5*(x-y))';
    case 9
        z=exp(-x.^2-y.^2);
        fstr='exp(-x.^2-y.^2)';
    case 10
        z=1./(1+25*(x.^2+y.^2));
        fstr='1./(1+25*(x.^2+y.^2))';
    case 11
        z=1./(1+25*(abs(x)+abs(y)));
        fstr='1./(1+25*(abs(x)+abs(y)))';
    case 12
        z=cos(20*(x+y));
        fstr='cos(20*(x+y))';
end


